# simple-short  :

   URL shorten in the easy & pretty way  : No databases connection , No web-services .... Just a simple algorithm for generating Unique Shorten URL. 

# Install :

   ```bash
   npm install simple-short;
   ```
# Use cases :

   let :

```js
shorten=require('simple-short');
```

## 1.  Generate Shorten ID [Async] :

  ```js    
    shorten('http://abdennoor.com',function(sid){
             console.log(sid);
    });
  ```  

## 2.  Generate Shorten ID [Sync] :

  ```js

    var sid=shorten('http://abdennoor.com'); // This case will be the most used by programmers
  ```  

## 3.  Suggest Shorten ID [Async] :

  ```js

    shorten('http://abdennoor.com','my-cv',function(available){
             if(!available){
               // another attempt ==> another call with replacing "my-cv" by other shorten-ID
             }
    });
  ```  
## 4.  Suggest Shorten ID [Sync] :

  ```js

    var available=shorten('http://abdennoor.com','my-cv');
    if(!available){
      //another attempt
    }
  ```  

## 5.  Retrieve URL of  Shorten ID [Async] :

  ```js

    shorten('er3Rfq',function(url){
             if(url){
             }
    });
  ```  
## 6.  Retrieve URL of  Shorten ID [Async] :

  ```js
  var url=shorten('er3Rfq'); // the opposite of Use-Case (2)

  ```  


## 7.  Use with `http` server :

  ```js
  http.createServer((req,res)=>{
        let url=shorten(req.url.slice(1)); // slice to remove slash  : "/er3Rfq" --> "er3Rfq"
        res.writeHead(301,{Location: url});
        res.end();
  }).listen(3000);

  ```  
## 8.  Use with `express` Framework :

   ```js

       shorten.all().forEach((sid)=>{
           app.get(`/${sid}`,(req,res)=>{
                 let url=shorten(sid);
                 res.redirect(url);
           })
       })
   ```

# Configuration :

  ```js
      shorten.conf({length:3});
      //Set Size of shorten-ID is 3 (Default is 4)
  ```       

# License :



      Copyright (c) 2016 Abdennour TOUMI <http://abdennoor.com>

      Permission is hereby granted, free of charge, to any person obtaining a copy
      of this software and associated documentation files (the "Software"), to deal
      in the Software without restriction, including without limitation the rights
      to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
      copies of the Software, and to permit persons to whom the Software is
      furnished to do so, subject to the following conditions:

      The above copyright notice and this permission notice shall be included in
      all copies or substantial portions of the Software.

      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
      OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
      THE SOFTWARE.
